#include "main.h"

bool operator==(a_lhs const left, a_lhs const right) {
	return ((left.src==right.src)&&(left.lab==right.lab));
}

bool operator<(a_lhs const left, a_lhs const right) {
	return ((left.src<right.src)||((left.src==right.src)&&(left.lab<right.lab)));
}


bool operator==(pre_post_item  const left, pre_post_item const right) {
	return ((left.state==right.state)&&(left.symbol==right.symbol));
}


bool operator<(pre_post_item const left, pre_post_item const right) {
	return ((left.state<right.state)||((left.state==right.state)&&(left.symbol<right.symbol)));
}

std::ostream& operator<< (std::ostream& os, const product_state a) {
	os << " [ <";
	for (int j=0; j<a.l.size();j++) 
		os << a.l[j]<< ",";
	os <<"> (";
	for(std::set<int>::iterator i=a.r.begin();i!=a.r.end();++i) 
		os << *i<<",";
	os <<")] ";
	return os;
}

